<?php

class NetworkWizard
{
	// Ids Network Mode
	var $netword_ids_array = array();

	var $id_lanmode	  = 'lan-mode'  ;
	var $id_lanstatic = 'lan-static';
	var $id_landhcp   = 'lan-dhcp'  ;
	var $id_wanstatic = 'wan-static';
	var $id_wandhcp   = 'wan-dhcp'  ;

	var $network_associated_parameter = array(	'lan-mode'   => 'LanMode'  ,
							'lan-static' => 'LanStatic',
							'lan-dhcp'   => 'LanDhcp'  ,
							'wan-static' => 'WanStatic',
							'wan-dhcp'   => 'WanDhcp'  );

	// Ids LAN
	var $lan_ids_array = array();

	var $id_lanip 		= 'lan-ipaddr'		;
	var $id_lannetmask 	= 'lan-netmask'		;
	var $id_langateway	= 'lan-gateway'		;

	var $lan_associated_parameter = array( 	'lan-ipaddr' 	 => 'LanIpAddr'		,
						'lan-netmask'	 => 'LanNetmask'	,
						'lan-gateway'	 => 'LanGateway' 	);
	// Ids WAN
	var $wan_ids_array = array();

	var $id_wanip		= 'wan-ipaddr' ;
	var $id_wannetmask 	= 'wan-netmask';
	var $id_wangateway	= 'wan-gateway';

	var $wan_associated_parameter = array(	'wan-ipaddr'	=> 'WanIpAddr'	,
						'wan-netmask'	=> 'WanNetmask' ,
						'wan-gateway'	=> 'WanGateway'	);

	// Ids DNS
	var $dns_ids_array = array();

	var $id_dnsnameserver	= 'lan-nameserver' ;
	var $id_dnsnameserver2	= 'lan-nameserver2';
	var $id_dnshostname 	= 'hostname'	   ;

	var $dns_associated_parameter = array(	'lan-nameserver' => 'DnsNameserver'	,
						'lan-nameserver2'=> 'DnsNameserver2'	,
						'hostname'	 => 'DnsHostname'	);

	function __construct ($init = true)
	{
		if (true)
		{
        		$this -> network_ids_array = array(	$this -> network_associated_parameter[$this -> id_lanmode]       => array( 'id' => $this -> id_lanmode   , 'object' => '.value'              ),
               		                			$this -> network_associated_parameter[$this -> id_lanstatic]     => array( 'id' => $this -> id_lanstatic , 'object' => '.checked.toString()' ),
               		                			$this -> network_associated_parameter[$this -> id_landhcp]       => array( 'id' => $this -> id_landhcp   , 'object' => '.checked.toString()' ),
               		                			$this -> network_associated_parameter[$this -> id_wanstatic]     => array( 'id' => $this -> id_wanstatic , 'object' => '.checked.toString()' ),
               		                			$this -> network_associated_parameter[$this -> id_wandhcp] 	 => array( 'id' => $this -> id_wandhcp	 , 'object' => '.checked.toString()' ));

              		$this -> lan_ids_array = array(	$this -> lan_associated_parameter[$this -> id_lanip]    	=> array( 'id' => $this -> id_lanip	    , 'object' => '.value' ),
            	   	                 		$this -> lan_associated_parameter[$this -> id_lannetmask]	=> array( 'id' => $this -> id_lannetmask    , 'object' => '.value' ),
                        	        		$this -> lan_associated_parameter[$this -> id_langateway]	=> array( 'id' => $this -> id_langateway    , 'object' => '.value' ));

			$this -> wan_ids_array = array(	$this -> wan_associated_parameter[$this -> id_wanip] 	  => array( 'id' => $this -> id_wanip 	   , 'object' => '.value' ),
							$this -> wan_associated_parameter[$this -> id_wannetmask] => array( 'id' => $this -> id_wannetmask , 'object' => '.value' ),
							$this -> wan_associated_parameter[$this -> id_wangateway] => array( 'id' => $this -> id_wangateway , 'object' => '.value' ));

			$this -> dns_ids_array = array(	$this -> dns_associated_parameter[$this -> id_dnsnameserver] 	=> array( 'id' => $this -> id_dnsnameserver  , 'object' => '.value' ),
							$this -> dns_associated_parameter[$this -> id_dnsnameserver2] 	=> array( 'id' => $this -> id_dnsnameserver2 , 'object' => '.value' ),
							$this -> dns_associated_parameter[$this -> id_dnshostname] 	=> array( 'id' => $this -> id_dnshostname    , 'object' => '.value' ));
		}
	}

	// Private Functions
	function _get_parameter_value ($saveNet, $bc, $network_cfg, $id_parameter, $type = 'dns', &$dhcp_checked = '', &$static_checked = '')
	{
		if (strcmp($type, 'lan') == 0)
		{
			$associated_parameter = $this -> lan_associated_parameter[$id_parameter];
		}
		else if (strcmp($type, 'wan') == 0)
		{
			$associated_parameter = $this -> wan_associated_parameter[$id_parameter];
		}
		else 
		{
			$associated_parameter = $this -> dns_associated_parameter[$id_parameter];
		} 

		$value = '';
		if (!(isset($network_cfg[$associated_parameter])))
		{
			$bool_nameserver  = (strcmp($id_parameter, $this -> id_dnsnameserver) == 0);
			$bool_nameserver2 = (strcmp($id_parameter, $this -> id_dnsnameserver2) == 0);

			if ($bool_nameserver || $bool_nameserver2)
			{
	        		$nameserver = $bc -> get('root', $this -> id_dnsnameserver);
	        		$dns = explode(';', $nameserver);

	        		$dhcp = in_array($bc -> get('root', $this -> id_landhcp), array('yes', '1'));
	        		if ((strcmp($saveNet, 'true') == 0) && $dhcp)
	        		{
	        		        $dns[0]         = '8.8.8.8';
	        		        $dns[1]         = '8.8.4.4';
	               			$dhcp_checked   = 'checked';
	               			$static_checkd  = '';
	       	 		}

				$value = ($bool_nameserver ? $dns[0] : $dns[1]);
			}
			else 
			{
				$value = $bc -> get('root', $id_parameter);
			}
		}

	        return (isset($network_cfg[$associated_parameter]) ? $network_cfg[$associated_parameter] : (($saveNet) ? $value : ''));
	}

	function _display_simple_field ($div_id, $label, $input_id, $title, $value = '', $type = 'text', $javascript = '', $tab = '', $autocomplete = '')
	{
	        $class = "class='form-control input-sm'";
	        if (strcmp($type, 'checkbox') == 0)
	        {
	                $class = "class=''";
	        }

	        $html_str =     "$tab\t\t\t<div class='form-group' id='$div_id'>\n".
	                        "$tab\t\t\t\t<label for='$input_id' class='col-sm-3 control-label'>$label</label>\n".
	                        "$tab\t\t\t\t<div class='col-sm-8'>\n".
	                        "$tab\t\t\t\t\t<input type='$type' $class data-toggle='tooltip' name='$input_id' id='$input_id' title='$title' value='$value' $javascript $autocomplete/>\n".
	                        "$tab\t\t\t\t</div>\n".
	                        "$tab\t\t\t</div>\n";

	        return $html_str;
	}

	function _display_network_mode ($saveNet, $bc, $network_cfg)
	{
	        $lan_selected    = 'selected';
	        $lanwan_selected = '';

        	if (isset($network_cfg['Mode']))
        	{
        	        if (strcmp($network_cfg['Mode'], 'lan-wan') == 0)
        	        {
        	                $lan_selected    = '';
        	                $lanwan_selected = 'selected';
        	        }
        	}
        	else
        	{
           	     if ($saveNet && (strcmp($bc -> get('root', $this -> id_lanmode), 'lan-wan') == 0))
           	     {
           	             $lan_selected    = '';
           	             $lanwan_selected = 'selected';
           	     }
        	}

        	ob_start();
?>
			<div class='form-group' style='margin-top: 15px;'>
				<label for='bonding-mode' class='col-sm-5 control-label'>LAN-Mode</label>
				<div class='col-sm-4'>
					<select class="form-control input-sm" name="<?php echo str_replace("-", "_", $this -> id_lanmode); ?>" id="<?php echo $this -> id_lanmode; ?>">
						<option value="single" <?php echo $lan_selected; ?>> Single mode</option>
						<option value="lan-wan" <?php echo $lanwan_selected; ?>> LAN-WAN</option>
					</select>
				</div>
			</div>
<?php
        	return ob_get_clean();
	}

	function _display_lan_settings ($saveNet, $bc, $network_cfg, &$dhcp_checked, &$static_checked, $type = 'lan')
	{
		$lan_ipaddr 	 = $this -> _get_parameter_value($saveNet, $bc, $network_cfg, $this -> id_lanip		, $type, $dhcp_checked, $static_checked);
		$lan_netmask 	 = $this -> _get_parameter_value($saveNet, $bc, $network_cfg, $this -> id_lannetmask	, $type, $dhcp_checked, $static_checked);
		$lan_gateway 	 = $this -> _get_parameter_value($saveNet, $bc, $network_cfg, $this -> id_langateway	, $type, $dhcp_checked, $static_checked);

        	$html_str = '';
        	ob_start();
?>
			<p class="text-center h5" id="header-lan"><?php echo NETWORK_LAN_SETTING_DIS; ?></p>
			<div class="form-group" id="<?php echo $this -> id_landhcp; ?>-tr">
				<div class="text-center">
					<input type="radio" name="dhcp" id="<?php echo $this -> id_landhcp; ?>" onclick="hide_netconfig(document.getElementById('<?php echo $this -> id_lanstatic; ?>').checked);"
														data-toggle="tooltip" title="<?php echo NET_CONF_DHCP; ?>" value="yes" <?php echo $dhcp_checked; ?>/> DHCP
					<input type="radio" name="dhcp" id="<?php echo $this -> id_lanstatic; ?>" onclick="hide_netconfig(document.getElementById('<?php echo $this -> id_lanstatic; ?>').checked);"
															data-toggle="tooltip" title="<?php echo NET_CONF_STATIC;?>" value="no" <?php echo $static_checked;?>/><?php echo NETWORK_STATIC_DIS; ?>
				</div>
			</div>
<?php
		$javascript_netmask = 'onclick="if (document.getElementById(\''. $this -> id_lannetmask .'\').value == \'\') netmask.value = makeNetMask(document.getElementById(\''. $this -> id_lanip .'\').value);"';

        	$html_str .=      ob_get_clean()
                	        . $this -> _display_simple_field( $this -> id_lanip .'-tr'	   , NETWORK_IP_ADDRESS_DIS           , $this -> id_lanip 	  , NET_CONF_IP_ADDRESS          , $lan_ipaddr     )
                	        . $this -> _display_simple_field( $this -> id_lannetmask .'-tr'    , NETWORK_NETMASK_DIS              , $this -> id_lannetmask    , NET_CONF_NETMASK             , $lan_netmask    , 'text' , $javascript_netmask  )
                        	. $this -> _display_simple_field( $this -> id_langateway .'-tr'    , NETWORK_GATEWAY_DIS              , $this -> id_langateway	  , NET_CONF_GATEWAY             , $lan_gateway    , 'text' );

        	return $html_str . ob_get_clean();
	}

	function _display_wan_settings ($saveSet, $bc, $network_cfg, &$dhcp_checked, &$static_checked, $type = 'wan')
	{
		$wan_ipaddr 	= $this -> _get_parameter_value( $saveNet, $bc, $network_cfg, $this -> id_wanip		, $type, $dhcp_checked, $static_checked);
		$wan_netmask	= $this -> _get_parameter_value( $saveNet, $bc, $network_cfg, $this -> id_wannetmask	, $type, $dhcp_checked, $static_checked);
		$wan_gateway	= $this -> _get_parameter_value( $saveNet, $bc, $network_cfg, $this -> id_wangateway	, $type, $dhcp_checked, $static_checked);

	        $html_str = '';
	        ob_start();
?>
			<div id="wan">
				<p class="text-center h5"><? echo NETWORK_WAN_SETTING_DIS; ?></p>
				<div class='form-group'>
					<div class='text-center'>
						<input type="radio" name="wan_dhcp" id="<?php echo $this -> id_wandhcp; ?>" onclick="hide_wan($('#<?php echo $this -> id_wanstatic; ?>').prop('checked'));"  value="1" 
							<? echo $dhcp_checked; ?>>&nbsp; DHCP
						<input type="radio" name="wan_dhcp" id="<?php echo $this -> id_wanstatic; ?>" onclick="hide_wan($('#<?php echo $this -> id_wanstatic; ?>').prop('checked'));" value="0" 
							<? echo $static_checked; ?>>&nbsp; <? echo NETWORK_STATIC_DIS; ?>
					</div>
				</div>
<?php
        	$html_str .=      ob_get_clean()
        	                . $this -> _display_simple_field( $this -> id_wanip .'-tr' 	, NETWORK_IP_ADDRESS_DIS, $this -> id_wanip	, '', $wan_ipaddr , 'text', '', "\t")
        	                . $this -> _display_simple_field( $this -> id_wannetmask .'-tr'	, NETWORK_NETMASK_DIS   , $this -> id_wannetmask, '', $wan_netmask, 'text', '', "\t")
        	                . $this -> _display_simple_field( $this -> id_wangateway .'-tr'	, NETWORK_GATEWAY_DIS   , $this -> id_wangateway, '', $wan_gateway, 'text', '', "\t");

        	ob_start();
?>
			</div>
<?php
       		return $html_str . ob_get_clean();
	}

	function _display_dns_settings($saveNet, $bc, $network_cfg)
	{
		$dns_nameserver  = $this -> _get_parameter_value($saveNet, $bc, $network_cfg, $this -> id_dnsnameserver	);
		$dns_nameserver2 = $this -> _get_parameter_value($saveNet, $bc, $network_cfg, $this -> id_dnsnameserver2);
		$dns_hostname 	 = $this -> _get_parameter_value($saveNet, $bc, $network_cfg, $this -> id_dnshostname	);

		ob_start();
?>
				<p class="text-center h5"><? echo NETWORK_DNS_SETTING_DIS; ?></p>
<?

		return 	  ob_get_clean()
			. $this -> _display_simple_field( $this -> id_dnsnameserver .'-tr' , NETWORK_PRIMARY_NAME_SERVER_DIS  , $this -> id_dnsnameserver , NET_CONF_NAMESERVER          , $dns_nameserver )
                        . $this -> _display_simple_field( $this -> id_dnsnameserver2 .'-tr', NETWORK_SECONDARY_NAME_SERVER_DIS, $this -> id_dnsnameserver2, NET_CONF_SECONDARY_NAMESERVER, $dns_nameserver2)
                        . $this -> _display_simple_field( $this -> id_dnshostname .'-tr'   , NETWORK_HOSTNAME_DIS             , $this -> id_dnshostname	  , NET_CONF_HOSTNAME            , $dns_hostname   , 'text' , 'checkDigChar="true"');
	}

	function _summary_lan_settings ($network_settings, $wan_set)
	{
		$html_str = "<p class='text-center h5'>". NETWORK_LAN_SETTING_DIS ."</p>\n";

		if ($network_settings['LanDhcp'])
		{
			return $html_str . "DHCP\n";
		}

		$network_names =	array( 	'LanIpAddr'	=> NETWORK_IP_ADDRESS_DIS		,	
						'LanNetmask'	=> NETWORK_NETMASK_DIS			,
						'LanGateway'	=> NETWORK_GATEWAY_DIS			,
						'LanNameServer'	=> NETWORK_PRIMARY_NAME_SERVER_DIS	,
						'LanNameServer2'=> NETWORK_SECONDARY_NAME_SERVER_DIS	,
						'LanHostname'	=> NETWORK_HOSTNAME_DIS			);

		if ($wan_set)
		{
			unset($network_names['LanGateway']);
		}

		return "\t\t\t<div class='left' style='margin-left: 50px;'>\n". $this -> display_parameters_value($network_names, $network_settings) ."\t\t\t</div>";
	}

	function _summary_wan_settings ($network_settings)
	{
		$html_str = "<p class='text-center h5'>". NETWORK_WAN_SETTING_DIS ."</p>\n";

		if ($network_settings['WanDhcp'])
		{
			return $html_str . "DHCP\n";
		}

		$network_names =	array(	$this -> wan_associated_parameter[$this -> id_wanip]		=> NETWORK_IP_ADDRESS_DIS,
						$this -> wan_associated_parameter[$this -> id_wannetmask]	=> NETWORK_NETMASK_DIS	 ,
						$this -> wan_associated_parameter[$this -> id_wangateway]	=> NETWORK_GATEWAY_DIS	 );
	
		return "\t\t\t<div class='left' style='margin-left: 100px;'>\n". $this -> display_parameters_value($network_names, $network_settings) ."\t\t\t</div>";
	}

	function _summary_dns_settings()
	{
		$html_str = '';

		return $html_str;
	}

	// Public Functions
	function get_network_ids_array ()
	{
		return $this -> network_ids_array;
	}

	function get_lan_ids_array ()
	{
		return $this -> lan_ids_array;
	}

	function get_wan_ids_array ()
	{
		return $this -> wan_ids_array;
	}

	function get_dns_ids_array ()
	{
		return $this -> dns_ids_array;
	}

	function get_ids_array ()
	{
		return array_merge($this -> network_ids_array, $this -> lan_ids_array, $this -> wan_ids_array, $this -> dns_ids_array);
	}

	function get_content_modal ($saveNet, $bc, $network_cfg)
	{
	        $dhcp_checked   = '';
	        $static_checked = 'checked';

       		return	  $this -> _display_network_mode($saveNet, $bc, $network_cfg)
            		. $this -> _display_lan_settings($saveNet, $bc, $network_cfg, $dhcp_static, $static_checked)
                      	. $this -> _display_wan_settings($saveNet, $bc, $network_cfg, $dhcp_static, $static_checked)
                      	. $this -> _display_dns_settings($saveNet, $bc, $network_cfg);
	} 

	function get_javascript_code ()
	{
        	ob_start();
?>
<script type="text/javascript">
	function hide_netconfig(ch) 
	{
    		if (!ch) 
		{
        		$("#<?php echo $this -> id_lanip ."-tr"; ?>").hide();
        		$("#<?php echo $this -> id_lannetmask ."-tr"; ?>").hide();
        		$("#<?php echo $this -> id_langateway ."-tr"; ?>").hide();
    		} 
		else 
		{
        		$("#<?php echo $this -> id_lanip ."-tr"; ?>").show();
        		$("#<?php echo $this -> id_lannetmask ."-tr"; ?>").show();
        		$("#<?php echo $this -> id_langateway ."-tr"; ?>").show();
    		}
	}

	function hide_wan(ch) 
	{
    		if (!ch) 
		{
        		$("#<?php echo $this -> id_wanip ."-tr"; ?>").hide();
        		$("#<?php echo $this -> id_wannetmask ."-tr"; ?>").hide();
        		$("#<?php echo $this -> id_wangateway ."-tr"; ?>").hide();
    		}
		else 
		{
        		$("#<?php echo $this -> id_wanip ."-tr"; ?>").show();
        		$("#<?php echo $this -> id_wannetmask ."-tr"; ?>").show();
        		$("#<?php echo $this -> id_wangateway ."-tr"; ?>").show();
    		}	
	}

	function mode() 
	{
    		hide_netconfig($("#<?php echo $this -> id_lanstatic; ?>").prop("checked"));
    		hide_wan($("#<?php echo $this -> id_wanstatic; ?>").prop("checked"));

    		switch ($("select[name='<?php echo str_replace("-", "_", $this -> id_lanmode); ?>'] option:selected").val()) 
		{
        		case 'single':
            			$("#wan").hide();
            			$("#<?php echo $this -> id_landhcp; ?>-tr").show();
            			$("input[name='dhcp']").prop("disabled",false);
            			break;
        		case 'lan-wan':
            			$("#wan").show();
            			$("#<?php echo $this -> id_lanip; ?>-tr").show();
            			$("#<?php echo $this -> id_lannetmask; ?>-tr").show();

            			$("input[name='dhcp']").prop("disabled",true);
            			$("#<?php echo $this -> id_landhcp; ?>-tr").hide();
            			$("#<?php echo $this -> id_langateway; ?>-tr").hide();
            			break;
        		default :
           			$("#wan").hide();
            			$("#<?php echo $this -> id_landhcp; ?>-tr").show();
            			$("input[name='dhcp']").prop("disabled",false);
            			break;
   		}
	}

	$(document).ready(function () 
	{
    		mode();

    		$("select[name='<?php echo str_replace("-", "_", $this -> id_lanmode); ?>']").change(function () {
        		mode();
    		});

    		$("#Networkform").validate({
        		rules: {
            			'<?php echo $this -> id_lanip; ?>': {
                			verifyIP: true,
                			required: true
            			},
            			'<?php echo $this -> id_dnsnameserver2; ?>': {
                			verifyIP: true,
               				required: {
                    				depends: function (element) {
                        				return $("#<?php echo $this -> id_dnsnameserver; ?>").is(":filled");
                    				}
                			}
            			},
            			'<?php echo $this -> id_dnsnameserver; ?>': {
                			verifyIP: true,
            			},
            			'<?php echo $this -> id_langateway; ?>': {
                			verifyIP: true,
                			required: true
            			},
            			'<?php echo $this -> id_lannetmask; ?>': {
                			verifyIP: true,
                			required: true
            			},
            			'<?php echo $this -> id_wanip; ?>': {
                			verifyIP: true,
                			required: true
            			},
           			'<?php echo $this -> id_wannetmask; ?>': {
                			verifyIP: true,
                			required: true
            			},
            			'<?php echo $this -> id_wangateway; ?>': {
                			verifyIP: true,
                			required: true
            			},
        		}
    		});
    	});
</script>
<?php
        	return ob_get_clean();
	}

	function _organize_lan_settings ($network_settings)
	{
		$lan_settings = array();

		foreach ($this -> lan_associated_parameter as $id => $associated)
		{
			if (isset($network_settings[$associated]))
			{
				$lan_settings[$id] = $network_settings[$associated];
			}
		}

		return $lan_settings; 
	}

	function _organize_wan_settings ($network_settings)
	{
		$wan_settings = array();

		foreach ($this -> wan_associated_parameter as $id => $associated)
		{
			if (isset($network_settings[$associated]))
			{
				$wan_settings[$id] = $network_settings[$associated];
			}
		}

		return $wan_settings;
	}

	function _organize_dns_settings ($network_settings)
	{
		$dns_settings = array();

		foreach ($this -> dns_associated_parameter as $id => $associated)
		{
			if (isset($network_settings[$associated]))
			{
				$dns_settings[$id] = $network_settings[$associated];
			}
		}

		return $dns_settings;
	}

	function organize_settings ($network_settings)
	{
		// get LAN mode
		$static_mode = isset($network_settings[$this -> network_associated_parameter[$this -> id_lanstatic]]);

		$lan_settings = array();
		$dns_settings = array();
		if ($static_mode)
		{
			// LAN
			$lan_settings = $this -> _organize_lan_settings($network_settings); 

			// DNS
			$dns_settings = $this -> _organize_dns_settings($network_settings);
		}

		// WAN
		$wan_settings = array();
		if (strcmp($network_settings[$this -> network_associated_parameter[$this -> id_lanmode]], 'single') != 0)
		{
			$wan_settings = $this -> _organize_wan_settings($network_settings);
		}

		return array_merge($lan_settings, $dns_settings, $wan_settings);
	}

	function display_parameters_value ($array_names, $array_parameters)
	{
		$html_str = '';
	
		foreach ($array_names as $id_para => $name_para)
		{
			if (isset($array_parameters[$id_para]) && strlen($array_parameters[$id_para]) > 0)
			{
				$html_str .= "\t\t\t\t$name_para = {$array_parameters[$id_para]} <br/>";
			}
		}

		return $html_str . "\n";
	}

	function get_summary_settings ($network_settings)
	{
		$div_html_in  = "\t\t\t<div style='display: inline-block'>";
		$div_html_out = "\t\t\t</div>";

		$lan_parameters = array_keys($this -> lan_associated_parameter);
		$wan_parameters = array_keys($this -> wan_associated_parameter);
		$dns_parameters = array_keys($this -> dns_associated_parameter);
	
		$lan_str = '';
		$wan_str = '';
		$dns_str = '';
		foreach ($network_settings as $parameter => $value)
		{
			if (in_array($parameter, $lan_parameters))
			{
				$lan_str .= "$parameter = $value <br/>";
				continue;
			}
			else if (in_array($parameter, $wan_parameters))
			{
				$wan_str .= "$parameter = $value <br/>";
				continue;
			}

			$dns_str .= "$parameter = $value <br/>";
		}

		return $div_in . $lan_str . $wan_str . $dns_str . $div_out;
	}
}
?>
